#include <bits/stdc++.h>
#define ll long long
using namespace std;

const int MAXN = 1e5 + 5;

int N, K, D[MAXN];

int main()
{
    cin >> N >> K;
    for(int i = 1; i <= K; i++) cin >> D[i];
    for(int i = 1; i <= K; i++)
    {
        int sol = 0;
        for(int j = 1; j <= N; j++)
            if(D[i] % j == 0) sol ^= j;
        cout << sol << "\n";
    }
    return 0;
}